#include <stdio.h>
#include <stdlib.h>

void exit2() {
 printf("\nThank you for using the Quick Assembly SDK.");
 printf("\nDirect all questions, comments, flames, etc. to:");
 printf("\nwill_white25@hotmail.com\n\n\n");
 printf("Really Bored Productions II\nhttp:\\\\www.geocities.com\\");
 printf("really_bored_productions_2\n\n");
 exit(0);
}

void fput_num(FILE *fp, int val) {
 static num = 0;
 if (val >= 256) val = val - 256;
 if (num % 16 == 0)
  fprintf(fp, "\n .db %i", val);
 else
  fprintf(fp, ",%i", val);
  num++;
}

void fput_num2(FILE *fp, int val) {
 static num = 0;
 if (val >= 256) val = val - 256;
 if (num % 16 == 0)
  fprintf(fp, "\n dc.b %i", val);
 else
  fprintf(fp, ",%i", val);
  num++;
}

void read_pic(char *fname, char *new, int ss) {
 FILE *fp,* nw;
 char header[62];
 char pic[3840];
 char buffer[3840];
 int x, y, sw, sh;

 fp = fopen(fname, "rb");

 if (ss == 768) {
  sw = 12;
  sh = 64;
 }

 if (ss == 1024) {
  sw = 16;
  sh = 64;
 }

 if (ss == 2000) {
  sw = 20;
  sh = 100;
 }

 if (ss == 3840) {
  sw = 30;
  sh = 128;
 }

 if (fp == NULL) exit2();
 else {
  fread(&header, 62, 1, fp);
  fread(&buffer, ss, 1, fp);
  fclose(fp);
  if (errno != 0) {
   printf("Error reading %s -- file is corrupt!\n", fname);
   exit2();
  }
 nw = fopen(new, "w");
 fprintf(nw, "; Monochrome Bitmap converted with QASM\n");
 for(y = 0; y < sh; y++)
  for(x = 0; x < sw; x++) pic[(y * sw) + x] = buffer[(((sh - 1) - y) * sw) + x];
 for(x = 0; x < ss; x++) {
  if (ss < 1200) fput_num(nw, 255 - pic[x]);
  if (ss > 1500) fput_num2(nw, 255 - pic[x]);
  }
 }
 printf("\nDone!\n");
}

void main(int argc, char *argv[]) {
 FILE *fp, *nw;
 char code[2000];
 char cod[2000];
 char bckup[2000];
 char xc[5];
 char yc[100];
 int ti[10], x, y;

 if (argc == 1) {
  printf("\n\nProper Usage:\n\nqasm [inputfile] [outputfile] [Other] [Size]\n\n");
  printf("Where [inputfile] is usually a .txt or .bmp file and\n");
  printf("[outputfile] is usually a .asm or .z80 file. Please read\n");
  printf("QASM.html for [Other] and [Size] information.\n");
  exit2();
  }

 if (strstr(argv[3], "PIC")) {
  read_pic(argv[1], argv[2], atoi(argv[4]));
  exit2();
  }

 if ((nw = fopen(argv[2], "w")) != NULL) {
  if (strstr(argv[4], "np")) fprintf(nw, ";");
  fflush(nw);

  if (strstr(argv[3], "82")) {
   fprintf(nw, "crasm82\n\n.org $9104\n\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, ".db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\n");
   y = 82;
   }

  if (strstr(argv[3], "83")) {
   fprintf(nw, "asm83\n\n.org $9327\n\n");
   y = 83;
   }

  if (strstr(argv[3], "DoorsCS")) {
   fprintf(nw, "asm83\n\n.org $9327\n.db $AA\n jr Start\n.dw DCSinfo\n");
   fprintf(nw, ".db $05,00\n.dw DCSicon\n.dw $0000\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, "\nDCSinfo:\n.db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\n");
   fprintf(nw, "DCSicon:\n");
   for (x = 0; x < 15; x++) fprintf(nw, ".db %00000000, %00000000\n");
   fprintf(nw, "\nStart:\n");
   y = 87;
   }


  if (strstr(argv[3], "Ion1")) {
   fprintf(nw, "asm83\n\n.org $9327\n ret\n jr nc,Start\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, "\nIonInfo:\n.db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\nStart:\n");
   y = 89;
   }

  if (strstr(argv[3], "Ion2")) {
   fprintf(nw, "asm83p\n\n.org $9D95\n ret\n jr nc,Start\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, "\nIonInfo:\n.db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\nStart:\n");
   y = 90;
   }

  if (strstr(argv[3], "8X")) {
   fprintf(nw, "asm83p\n\n.org $9D95\n\n");
   y = 84;
   }

  if (strstr(argv[3], "MirageOS")) {
   fprintf(nw, "asm83p\n\n.org $9D93\n.db $BB,$6D\n ret\n.db 1\n\n");
   fprintf(nw, "MOSsprite:\n");
   for (x = 0; x < 15; x++) fprintf(nw, ".db %00000000, %00000000\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, "\n.db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\n");
   y = 88;
   }

  if (strstr(argv[3], "85")) {
   fprintf(nw, "zshell\n\n.org $0000\n\n");
   printf("\nPlease Enter Description:");
   gets(code);
   fprintf(nw, ".db \"");
   fprintf(nw, code);
   fprintf(nw, "\",0\n\n");
   y = 85;
   }

  if (strstr(argv[3], "86")) {
   fprintf(nw, "asm86\n\n.org $D748\n\n");
   y = 86;
   }

  }
  fflush(nw);

 if (argc == NULL) exit2();
 if ((fp = fopen(argv[1], "r")) != NULL) {
  if ((nw = fopen(argv[2], "a")) != NULL) {
   xc[4] = NULL;
   while(fgets(code, sizeof(code), fp)) {
    strcpy(bckup, "Hi");
    strcpy(cod, "Hi");
    if (strstr(code, " SmlText($") || strstr(code, " BigText($")) {
     strcpy(bckup, code);
     xc[0] = code[10];
     xc[1] = code[11];
     xc[2] = code[12];
     xc[3] = code[13];
     strcpy(cod, strstr(code, "\""));
     strcpy(code, " ld de,$");
     strcat(code, xc);
     }

    if (strstr(bckup, " SmlText($")) {
     ti[4] = 1;
     strcat(code, "\n ld hl,$+6\n call PutSm\n.db ");
     strncat(code, cod, strlen(cod) - 2);
     strcat(code, ",0\n");
     }

    if (strstr(bckup, " BigText($")) {
     ti[1] = 1;
     strcat(code, "\n ld hl,$+6\n call PutBig\n.db ");
     strncat(code, cod, strlen(cod) - 2);
     strcat(code, ",0\n");
     }

    if (strstr(code, " Return")) strcpy(code, " ret\n");
    if (strstr(code, " NC_Return")) strcpy(code, " ret nc\n");
    if (strstr(code, " C_Return")) strcpy(code, " ret c\n");
    if (strstr(code, " Z_Return")) strcpy(code, " ret z\n");
    if (strstr(code, " NZ_Return")) strcpy(code, " ret nz\n");
    if (strstr(code, " P_Return")) strcpy(code, " ret p\n");
    if (strstr(code, " M_Return")) strcpy(code, " ret m\n");
    if (strstr(code, " PO_Return")) strcpy(code, " ret po\n");
    if (strstr(code, " PE_Return")) strcpy(code, " ret pe\n");

    if (strstr(code, " Is_A(")) {
     strcpy(cod, "");
     strncat(cod, code, strlen(code) - 2);
     strcpy(code, " cp ");
     strcat(code, strstr(cod, "A(")+2);
     strcat(code, "\n");
     }

    if (strstr(code, " For(")) {
     strcpy(cod, "");
     strncat(cod, code, strlen(code) - 2);
     strcpy(code, "\n ld b,");
     strcat(code, strstr(cod, ",")+1);
     strcat(code, "\n");
     strncat(code, strstr(cod, "r(")+2, strlen(code) - 6);
     strcat(code, ":\n push bc\n");
     }

    if (strstr(code, " EndFor(")) {
     strcpy(cod, "");
     strncat(cod, code, strlen(code) - 2);
     strcpy(code, " pop bc\n djnz ");
     strncat(code, strstr(cod, "r(")+2, strlen(code) - 2);
     strcat(code, "\n\n");
     }

    if (y == 86) {
     if (strstr(code, " BusyOn")) strcpy(code, " call $4AAD\n");
     if (strstr(code, " NC_BusyOn")) strcpy(code, " call nc,$4AAD\n");
     if (strstr(code, " C_BusyOn")) strcpy(code, " call c,$4AAD\n");
     if (strstr(code, " NZ_BusyOn")) strcpy(code, " call nz,$4AAD\n");
     if (strstr(code, " Z_BusyOn")) strcpy(code, " call z,$4AAD\n");
     if (strstr(code, " P_BusyOn")) strcpy(code, " call p,$4AAD\n");
     if (strstr(code, " M_BusyOn")) strcpy(code, " call m,$4AAD\n");
     if (strstr(code, " PE_BusyOn")) strcpy(code, " call pe,$4AAD\n");
     if (strstr(code, " PO_BusyOn")) strcpy(code, " call po,$4AAD\n");
     if (strstr(code, " BusyOff")) strcpy(code, " call $4AB1\n");
     if (strstr(code, " NC_BusyOff")) strcpy(code, " call nc,$4AB1\n");
     if (strstr(code, " C_BusyOff")) strcpy(code, " call c,$4AB1\n");
     if (strstr(code, " Z_BusyOff")) strcpy(code, " call z,$4AB1\n");
     if (strstr(code, " NZ_BusyOff")) strcpy(code, " call nz,$4AB1\n");
     if (strstr(code, " P_BusyOff")) strcpy(code, " call p,$4AB1\n");
     if (strstr(code, " M_BusyOff")) strcpy(code, " call m,$4AB1\n");
     if (strstr(code, " PO_BusyOff")) strcpy(code, " call po,$4AB1\n");
     if (strstr(code, " PE_BusyOff")) strcpy(code, " call pe,$4AB1\n");
     if (strstr(code, " NewLine")) strcpy(code, " call $4A5F\n");
     if (strstr(code, " C_NewLine")) strcpy(code, " call c,$4A5F\n");
     if (strstr(code, " Z_NewLine")) strcpy(code, " call z,$4A5F\n");
     if (strstr(code, " NC_NewLine")) strcpy(code, " call nc,$4A5F\n");
     if (strstr(code, " NZ_NewLine")) strcpy(code, " call nz,$4A5F\n");
     if (strstr(code, " P_NewLine")) strcpy(code, " call p,$4A5F\n");
     if (strstr(code, " M_NewLine")) strcpy(code, " call m,$4A5F\n");
     if (strstr(code, " PO_NewLine")) strcpy(code, " call po,$4A5F\n");
     if (strstr(code, " PE_NewLine")) strcpy(code, " call pe,$4A5F\n");
     if (strstr(code, " Stop")) strcpy(code, " jp $409C\n");
     if (strstr(code, " Z_Stop")) strcpy(code, " jp z,$409C\n");
     if (strstr(code, " C_Stop")) strcpy(code, " jp c,$409C\n");
     if (strstr(code, " NZ_Stop")) strcpy(code, " jp nz,$409C\n");
     if (strstr(code, " NC_Stop")) strcpy(code, " jp nc,$409C\n");
     if (strstr(code, " P_Stop")) strcpy(code, " jp p,$409C\n");
     if (strstr(code, " M_Stop")) strcpy(code, " jp m,$409C\n");
     if (strstr(code, " PO_Stop")) strcpy(code, " jp po,$409C\n");
     if (strstr(code, " PE_Stop")) strcpy(code, " jp pe,$409C\n");
     if (strstr(code, " Pause")) strcpy(code, " call $4D43\n");
     if (strstr(code, " C_Pause")) strcpy(code, " call c,$4D43\n");
     if (strstr(code, " Z_Pause")) strcpy(code, " call z,$4D43\n");
     if (strstr(code, " NC_Pause")) strcpy(code, " call nc,$4D43\n");
     if (strstr(code, " NZ_Pause")) strcpy(code, " call nz,$4D43\n");
     if (strstr(code, " P_Pause")) strcpy(code, " call p,$4D43\n");
     if (strstr(code, " M_Pause")) strcpy(code, " call m,$4D43\n");
     if (strstr(code, " PO_Pause")) strcpy(code, " call po,$4D43\n");
     if (strstr(code, " PE_Pause")) strcpy(code, " call pe,$4D43\n");
     if (strstr(code, " ClLCD")) strcpy(code, " call $4A7E\n");
     if (strstr(code, " C_ClLCD")) strcpy(code, " call c,$4A7E\n");
     if (strstr(code, " NC_ClLCD")) strcpy(code, " call nc,$4A7E\n");
     if (strstr(code, " Z_ClLCD")) strcpy(code, " call z,$4A7E\n");
     if (strstr(code, " NZ_ClLCD")) strcpy(code, " call nz,$4A7E\n");
     if (strstr(code, " P_ClLCD")) strcpy(code, " call p,$4A7E\n");
     if (strstr(code, " M_ClLCD")) strcpy(code, " call m,$4A7E\n");
     if (strstr(code, " PO_ClLCD")) strcpy(code, " call po,$4A7E\n");
     if (strstr(code, " PE_ClLCD")) strcpy(code, " call pe,$4A7E\n");
     if (strstr(code, " C_DispG")) strcpy(code, " call c,$4D6F\n");
     if (strstr(code, " NC_DispG")) strcpy(code, " call nc,$4D6F\n");
     if (strstr(code, " Z_DispG")) strcpy(code, " call z,$4D6F\n");
     if (strstr(code, " NZ_DispG")) strcpy(code, " call nz,$4D6F\n");
     if (strstr(code, " DispG")) strcpy(code, " call $4D6F\n");
     if (strstr(code, " P_DispG")) strcpy(code, " call p,$4D6F\n");
     if (strstr(code, " M_DispG")) strcpy(code, " call m,$4D6F\n");
     if (strstr(code, " PO_DispG")) strcpy(code, " call po,$4D6F\n");
     if (strstr(code, " PE_DispG")) strcpy(code, " call pe,$4D6F\n");
     if (strstr(code, " ClrScrn")) strcpy(code, " call $4A82\n");
     if (strstr(code, " C_ClrScrn")) strcpy(code, " call c,$4A82\n");
     if (strstr(code, " NC_ClrScrn")) strcpy(code, " call nc,$4A82\n");
     if (strstr(code, " Z_ClrScrn")) strcpy(code, " call z,$4A82\n");
     if (strstr(code, " NZ_ClrScrn")) strcpy(code, " call nz,$4A82\n");
     if (strstr(code, " P_ClrScrn")) strcpy(code, " call p,$4A82\n");
     if (strstr(code, " M_ClrScrn")) strcpy(code, " call m,$4A82\n");
     if (strstr(code, " PO_ClrScrn")) strcpy(code, " call po,$4A82\n");
     if (strstr(code, " PE_ClrScrn")) strcpy(code, " call pe,$4A82\n");
     if (strstr(code, " HomeUp")) strcpy(code, " call $4A95\n");
     if (strstr(code, " C_HomeUp")) strcpy(code, " call c,$4A95\n");
     if (strstr(code, " NC_HomeUp")) strcpy(code, " call nc,$4A95\n");
     if (strstr(code, " Z_HomeUp")) strcpy(code, " call z,$4A95\n");
     if (strstr(code, " NZ_HomeUp")) strcpy(code, " call nz,$4A95\n");
     if (strstr(code, " P_HomeUp")) strcpy(code, " call p,$4A95\n");
     if (strstr(code, " M_HomeUp")) strcpy(code, " call m,$4A95\n");
     if (strstr(code, " PO_HomeUp")) strcpy(code, " call po,$4A95\n");
     if (strstr(code, " PE_HomeUp")) strcpy(code, " call pe,$4A95\n");
     if (strstr(code, " GetKey")) strcpy(code, " call $55AA\n");
     if (strstr(code, " C_GetKey")) strcpy(code, " call c,$55AA\n");
     if (strstr(code, " Z_GetKey")) strcpy(code, " call z,$55AA\n");
     if (strstr(code, " NC_GetKey")) strcpy(code, " call nc,$55AA\n");
     if (strstr(code, " NZ_GetKey")) strcpy(code, " call nz,$55AA\n");
     if (strstr(code, " P_GetKey")) strcpy(code, " call p,$55AA\n");
     if (strstr(code, " M_GetKey")) strcpy(code, " call m,$55AA\n");
     if (strstr(code, " PO_GetKey")) strcpy(code, " call po,$55AA\n");
     if (strstr(code, " PE_GetKey")) strcpy(code, " call pe,$55AA\n");

     if (strstr(code, " PutSml(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n call $4AA5\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutBig(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n call $4A37\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutCbg(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $4A2B\n");
      }
     if (strstr(code, " PutCsm(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $4AA1\n");
      }

     }

    if (y == 83 || y == 87 || y == 89) {
     if (strstr(code, " C_BusyOn")) strcpy(code, " call c,$4791\n");
     if (strstr(code, " NC_BusyOn")) strcpy(code, " call nc,$4791\n");
     if (strstr(code, " Z_BusyOn")) strcpy(code, " call z,$4791\n");
     if (strstr(code, " NZ_BusyOn")) strcpy(code, " call nz,$4791\n");
     if (strstr(code, " BusyOn")) strcpy(code, " call $4791\n");
     if (strstr(code, " P_BusyOn")) strcpy(code, " call p,$4791\n");
     if (strstr(code, " M_BusyOn")) strcpy(code, " call m,$4791\n");
     if (strstr(code, " PO_BusyOn")) strcpy(code, " call po,$4791\n");
     if (strstr(code, " PE_BusyOn")) strcpy(code, " call pe,$4791\n");
     if (strstr(code, " BusyOff")) strcpy(code, " call $4795\n");
     if (strstr(code, " C_BusyOff")) strcpy(code, " call c,$4795\n");
     if (strstr(code, " NC_BusyOff")) strcpy(code, " call nc,$4795\n");
     if (strstr(code, " Z_BusyOff")) strcpy(code, " call z,$4795\n");
     if (strstr(code, " NZ_BusyOff")) strcpy(code, " call nz,$4795\n");
     if (strstr(code, " P_BusyOff")) strcpy(code, " call p,$4795\n");
     if (strstr(code, " M_BusyOff")) strcpy(code, " call m,$4795\n");
     if (strstr(code, " PO_BusyOff")) strcpy(code, " call po,$4795\n");
     if (strstr(code, " PE_BusyOff")) strcpy(code, " call pe,$4795\n");
     if (strstr(code, " NewLine")) strcpy(code, " call $473D\n");
     if (strstr(code, " C_NewLine")) strcpy(code, " call c,$473D\n");
     if (strstr(code, " NC_NewLine")) strcpy(code, " call nc,$473D\n");
     if (strstr(code, " Z_NewLine")) strcpy(code, " call z,$473D\n");
     if (strstr(code, " NZ_NewLine")) strcpy(code, " call nz,$473D\n");
     if (strstr(code, " P_NewLine")) strcpy(code, " call p,$473D\n");
     if (strstr(code, " M_NewLine")) strcpy(code, " call m,$473D\n");
     if (strstr(code, " PO_NewLine")) strcpy(code, " call po,$473D\n");
     if (strstr(code, " PE_NewLine")) strcpy(code, " call pe,$473D\n");
     if (strstr(code, " Stop")) strcpy(code, " ret ; Hopefully\n");
     if (strstr(code, " C_Stop")) strcpy(code, " ret c; Hopefully\n");
     if (strstr(code, " NC_Stop")) strcpy(code, " ret nc; Hopefully\n");
     if (strstr(code, " Z_Stop")) strcpy(code, " ret z; Hopefully\n");
     if (strstr(code, " NZ_Stop")) strcpy(code, " ret nz; Hopefully\n");
     if (strstr(code, " P_Stop")) strcpy(code, " ret p; Hopefully\n");
     if (strstr(code, " M_Stop")) strcpy(code, " ret m; Hopefully\n");
     if (strstr(code, " PO_Stop")) strcpy(code, " ret po; Hopefully\n");
     if (strstr(code, " PE_Stop")) strcpy(code, " ret pe; Hopefully\n");
     if (strstr(code, " DispG")) strcpy(code, " call $91B6\n");
     if (strstr(code, " C_DispG")) strcpy(code, " call c,$91B6\n");
     if (strstr(code, " NC_DispG")) strcpy(code, " call nc,$91B6\n");
     if (strstr(code, " Z_DispG")) strcpy(code, " call z,$91B6\n");
     if (strstr(code, " NZ_DispG")) strcpy(code, " call nz,$91B6\n");
     if (strstr(code, " P_DispG")) strcpy(code, " call p,$91B6\n");
     if (strstr(code, " M_DispG")) strcpy(code, " call m,$91B6\n");
     if (strstr(code, " PO_DispG")) strcpy(code, " call po,$91B6\n");
     if (strstr(code, " PE_DispG")) strcpy(code, " call pe,$91B6\n");
     if (strstr(code, " ClLCD")) strcpy(code, " call $4755\n");
     if (strstr(code, " C_ClLCD")) strcpy(code, " call c,$4755\n");
     if (strstr(code, " NC_ClLCD")) strcpy(code, " call nc,$4755\n");
     if (strstr(code, " Z_ClLCD")) strcpy(code, " call z,$4755\n");
     if (strstr(code, " NZ_ClLCD")) strcpy(code, " call nz,$4755\n");
     if (strstr(code, " P_ClLCD")) strcpy(code, " call p,$4755\n");
     if (strstr(code, " M_ClLCD")) strcpy(code, " call m,$4755\n");
     if (strstr(code, " PO_ClLCD")) strcpy(code, " call po,$4755\n");
     if (strstr(code, " PE_ClLCD")) strcpy(code, " call pe,$4755\n");
     if (strstr(code, " ClrScrn")) strcpy(code, " call $475D\n");
     if (strstr(code, " C_ClrScrn")) strcpy(code, " call c,$475D\n");
     if (strstr(code, " NC_ClrScrn")) strcpy(code, " call nc,$475D\n");
     if (strstr(code, " Z_ClrScrn")) strcpy(code, " call z,$475D\n");
     if (strstr(code, " NZ_ClrScrn")) strcpy(code, " call nz,$475D\n");
     if (strstr(code, " P_ClrScrn")) strcpy(code, " call p,$475D\n");
     if (strstr(code, " M_ClrScrn")) strcpy(code, " call m,$475D\n");
     if (strstr(code, " PO_ClrScrn")) strcpy(code, " call po,$475D\n");
     if (strstr(code, " PE_ClrScrn")) strcpy(code, " call pe,$475D\n");
     if (strstr(code, " HomeUp")) strcpy(code, " call $4775\n");
     if (strstr(code, " Z_HomeUp")) strcpy(code, " call z,$4775\n");
     if (strstr(code, " C_HomeUp")) strcpy(code, " call c,$4775\n");
     if (strstr(code, " NZ_HomeUp")) strcpy(code, " call nz,$4775\n");
     if (strstr(code, " NC_HomeUp")) strcpy(code, " call nc,$4775\n");
     if (strstr(code, " P_HomeUp")) strcpy(code, " call p,$4775\n");
     if (strstr(code, " M_HomeUp")) strcpy(code, " call m,$4775\n");
     if (strstr(code, " PO_HomeUp")) strcpy(code, " call po,$4775\n");
     if (strstr(code, " PE_HomeUp")) strcpy(code, " call pe,$4775\n");
     if (strstr(code, " Pause")) strcpy(code, " call $4CFE\n");
     if (strstr(code, " C_Pause")) strcpy(code, " call c,$4CFE\n");
     if (strstr(code, " NC_Pause")) strcpy(code, " call nc,$4CFE\n");
     if (strstr(code, " Z_Pause")) strcpy(code, " call z,$4CFE\n");
     if (strstr(code, " NZ_Pause")) strcpy(code, " call nz,$4CFE\n");
     if (strstr(code, " P_Pause")) strcpy(code, " call p,$4CFE\n");
     if (strstr(code, " M_Pause")) strcpy(code, " call m,$4CFE\n");
     if (strstr(code, " PO_Pause")) strcpy(code, " call po,$4CFE\n");
     if (strstr(code, " PE_Pause")) strcpy(code, " call pe,$4CFE\n");
     if (strstr(code, " GetKey")) strcpy(code, " call $4CFE\n");
     if (strstr(code, " C_GetKey")) strcpy(code, " call c,$4CFE\n");
     if (strstr(code, " NC_GetKey")) strcpy(code, " call nc,$4CFE\n");
     if (strstr(code, " Z_GetKey")) strcpy(code, " call z,$4CFE\n");
     if (strstr(code, " NZ_GetKey")) strcpy(code, " call nz,$4CFE\n");
     if (strstr(code, " P_GetKey")) strcpy(code, " call p,$4CFE\n");
     if (strstr(code, " M_GetKey")) strcpy(code, " call m,$4CFE\n");
     if (strstr(code, " PO_GetKey")) strcpy(code, " call po,$4CFE\n");
     if (strstr(code, " PE_GetKey")) strcpy(code, " call pe,$4CFE\n");

     if (strstr(code, " PutSml(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n call $4781\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutBig(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n call $470D\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutCbg(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $4705\n");
      }
     if (strstr(code, " PutCsm(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $477D\n");
      }
     }


    if (y == 84 || y == 88 || y == 90) {
     if (strstr(code, " BusyOn")) strcpy(code, " rst 28h\n .dw $456D\n");
     if (strstr(code, " BusyOff")) strcpy(code, " rst 28h\n .dw $4570\n");
     if (strstr(code, " NewLine")) strcpy(code, " rst 28h\n .dw $452E\n");
     if (y == 84 || y == 90) {
      if (strstr(code, " Stop")) strcpy(code, " ret ; Hopefully\n");
      if (strstr(code, " C_Stop")) strcpy(code, " ret c; Hopefully\n");
      if (strstr(code, " NC_Stop")) strcpy(code, " ret nc; Hopefully\n");
      if (strstr(code, " Z_Stop")) strcpy(code, " ret z; Hopefully\n");
      if (strstr(code, " NZ_Stop")) strcpy(code, " ret nz; Hopefully\n");
      if (strstr(code, " P_Stop")) strcpy(code, " ret p; Hopefully\n");
      if (strstr(code, " M_Stop")) strcpy(code, " ret m; Hopefully\n");
      if (strstr(code, " PO_Stop")) strcpy(code, " ret po; Hopefully\n");
      if (strstr(code, " PE_Stop")) strcpy(code, " ret pe; Hopefully\n");
     }
     if (strstr(code, " DispG")) {
      strcpy(code, " call DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " C_DispG")) {
      strcpy(code, " call c,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " NC_DispG")) {
      strcpy(code, " call nc,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " Z_DispG")) {
      strcpy(code, " call z,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " NZ_DispG")) {
      strcpy(code, " call nz,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " P_DispG")) {
      strcpy(code, " call p,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " M_DispG")) {
      strcpy(code, " call m,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " PO_DispG")) {
      strcpy(code, " call po,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " PE_DispG")) {
      strcpy(code, " call pe,DispG\n");
      ti[7] = 1;
     }
     if (strstr(code, " ClLCD")) strcpy(code, " rst 28h\n .dw $4540\n");
     if (strstr(code, " ClrScrn")) strcpy(code, " rst 28h\n .dw $4546\n");
     if (strstr(code, " HomeUp")) strcpy(code, " rst 28h\n .dw $4A5F\n");
     if (strstr(code, " Pause")) strcpy(code, " rst 28h\n .dw $4972\n");
     if (strstr(code, " GetKey")) strcpy(code, " rst 28h\n .dw $4972\n");
     if (y == 88) {
     if (strstr(bckup, " Stop")) strcpy(code, " rst 28h\n .dw $40B9\n");
      }
     if (strstr(code, " PutSml(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n rst 28h\n .dw $4561\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutBig(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+6\n rst 28h\n .dw $450A\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutCbg(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n rst 28h\n .dw $4504\n");
      }
     if (strstr(code, " PutCsm(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n rst 28h\n .dw $455E\n");
      }
     }

    if (y == 82) {
     if (strstr(code, " Stop")) strcpy(code, " jp $8D88\n");
     if (strstr(code, " C_Stop")) strcpy(code, " jp c,$8D88\n");
     if (strstr(code, " Z_Stop")) strcpy(code, " jp z,$8D88\n");
     if (strstr(code, " M_Stop")) strcpy(code, " jp m,$8D88\n");
     if (strstr(code, " P_Stop")) strcpy(code, " jp p,$8D88\n");
     if (strstr(code, " NC_Stop")) strcpy(code, " jp nc,$8D88\n");
     if (strstr(code, " NZ_Stop")) strcpy(code, " jp nz,$8D88\n");
     if (strstr(code, " PO_Stop")) strcpy(code, " jp po,$8D88\n");
     if (strstr(code, " PE_Stop")) strcpy(code, " jp pe,$8D88\n");
     if (strstr(code, " GetKey")) strcpy(code, " call $01D4\n");
     if (strstr(code, " C_GetKey")) strcpy(code, " call c,$01D4\n");
     if (strstr(code, " M_GetKey")) strcpy(code, " call m,$01D4\n");
     if (strstr(code, " P_GetKey")) strcpy(code, " call p,$01D4\n");
     if (strstr(code, " Z_GetKey")) strcpy(code, " call z,$01D4\n");
     if (strstr(code, " NC_GetKey")) strcpy(code, " call nc,$01D4\n");
     if (strstr(code, " NZ_GetKey")) strcpy(code, " call nz,$01D4\n");
     if (strstr(code, " PO_GetKey")) strcpy(code, " call po,$01D4\n");
     if (strstr(code, " PE_GetKey")) strcpy(code, " call pe,$01D4\n");
     if (strstr(code, " ClLCD")) strcpy(code, " call $8D74\n.dw $389A\n");
     if (strstr(code, " ClrScrn")) strcpy(code, " call $8D74\n.dw $37A4\n");
     if (strstr(code, " NewLine")) strcpy(code, " call $8D74\n.dw $377A\n");
     if (strstr(code, " DispG")) strcpy(code, " call $8D74\n.dw $38AC\n");
     if (strstr(code, " HomeUp")) strcpy(code, " call $8D74\n.dw $3786\n");
     if (strstr(code, " Pause")) {
      strcpy(code, " call Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " C_Pause")) {
      strcpy(code, " call c,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " P_Pause")) {
      strcpy(code, " call p,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " Z_Pause")) {
      strcpy(code, " call z,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " M_Pause")) {
      strcpy(code, " call m,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " NC_Pause")) {
      strcpy(code, " call nc,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " NZ_Pause")) {
      strcpy(code, " call nz,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " PO_Pause")) {
      strcpy(code, " call po,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " PE_Pause")) {
      strcpy(code, " call pe,Pause\n");
      ti[5] = 1;
     }
     if (strstr(code, " PutSml(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+8\n call $8D74\n.dw $37D4\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutBig(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld hl,$+8\n call $8D74\n.dw $38FA\n.db ");
      strncat(code, cod, strlen(cod) - 2);
      strcat(code, ",0\n");
      }
     if (strstr(code, " PutCbg(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $8D74\n .dw $3738");
      }
     if (strstr(code, " PutCsm(")) {
      strcpy(cod, strstr(code, "\""));
      strcpy(code, " ld a,'");
      strncat(code, cod + 1, strlen(cod) - 3);
      strcat(code, "'\n call $8D74\n .dw $37CE");
      }
    }

    if (strstr(code, " InvText")) {
     strcpy(code, " call InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " C_InvText")) {
     strcpy(code, " call c,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " M_InvText")) {
     strcpy(code, " call m,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " P_InvText")) {
     strcpy(code, " call p,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " Z_InvText")) {
     strcpy(code, " call z,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " NC_InvText")) {
     strcpy(code, " call nc,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " NZ_InvText")) {
     strcpy(code, " call nz,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " PE_InvText")) {
     strcpy(code, " call pe,InvText\n");
     ti[2] = 1;
    }
    if (strstr(code, " PO_InvText")) {
     strcpy(code, " call po,InvText\n");
     ti[2] = 1;
    }

    if (strstr(code, " ClrGraph")) {
     strcpy(code, " call ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " PO_ClrGraph")) {
     strcpy(code, " call po,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " C_ClrGraph")) {
     strcpy(code, " call c,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " M_ClrGraph")) {
     strcpy(code, " call m,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " P_ClrGraph")) {
     strcpy(code, " call p,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " Z_ClrGraph")) {
     strcpy(code, " call z,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " NC_ClrGraph")) {
     strcpy(code, " call nc,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " NZ_ClrGraph")) {
     strcpy(code, " call nz,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(code, " PE_ClrGraph")) {
     strcpy(code, " call pe,ClrG\n");
     ti[3] = 1;
    }

    if (y != 85) {
    if (strstr(code, " Sprite($")) {
     ti[6] = 1;
     strcpy(bckup, code);
     xc[0] = code[9];
     xc[1] = code[10];
     xc[2] = code[11];
     xc[3] = code[12];
     xc[4] = NULL;
     yc[0] = code[16];
     yc[1] = code[17];
     yc[2] = code[18];
     yc[3] = code[19];
     yc[4] = NULL;
     strcpy(cod, strstr(code, "\"") + 1);
     strcpy(code, " ld de,$");
     strcat(code, xc);
     strcat(code, "\n ld hl,$");
     strcat(code, yc);
     strcat(code, "\n ld ix,");
     strncat(code, cod, strlen(cod) - 3);
     strcat(code, "\n call PutSprite\n");
     }
    }

    fputs(code, nw);
    fflush(nw);
  }

   if (ti[2] == 1) {
    fprintf(nw, "\nInvText:\n bit 3,(iy+5)\n jr nz,ResText\n set 3,(iy+5)");
    fprintf(nw, "\n ret\nResText:\n res 3,(iy+5)\n ret\n");
   }

   if (y == 86) {
    if (ti[1] == 1) {
     fprintf(nw, "\nPutBig:\n ld a,d\n ld ($C00F),a\n ld a,e");
     fprintf(nw, "\n ld ($C010),a\n jp $4A37\n");
    }
    if (ti[3] == 1) {
     fprintf(nw, "\nClrG:\n ld hl,$C9FA\n ld de,$C9FB\n ld bc,$3FF\n ld (hl),0");
     fprintf(nw, "\n ldir\n ret\n");
    }
    if (ti[4] == 1) {
     fprintf(nw, "\nPutSm:\n ld a,d\n ld ($C37D),a\n ld a,e");
     fprintf(nw, "\n ld ($C37C),a\n jp $4AA5\n");
    }

    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d\n");
     fprintf(nw, "Core:\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n djnz Core\n");
     fprintf(nw, " ld bc,16\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n djnz DecLoop");
     fprintf(nw, "\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 83 || y == 87 || y == 89) {
    if (ti[1] == 1) {
     fprintf(nw, "\nPutBig:\n ld a,d\n ld ($800C),a\n ld a,e");
     fprintf(nw, "\n ld ($800D),a\n jp $470D\n");
    }
    if (ti[3] == 1) {
     fprintf(nw, "\nClrG:\n ld hl,$8E29\n ld de,$8E2A\n ld bc,767\n ld (hl),0");
     fprintf(nw, "\n ldir\n ret\n");
    }
    if (ti[4] == 1) {
     fprintf(nw, "\nPutSm:\n ld a,d\n ld ($8253),a\n ld a,e");
     fprintf(nw, "\n ld ($8252),a\n jp $4781\n");
    }
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld bc,14\n add ix,de\n ld b,e\n xor c\nHeight:\n");
     fprintf(nw, " push bc\n ld b,d\nCore:\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n");
     fprintf(nw, " djnz Core\n ld bc,12\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n");
     fprintf(nw, " djnz DecLoop\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 82) {
    if (ti[1] == 1) {
     fprintf(nw, "\nPutBig:\n ld a,d\n ld ($800C),a\n ld a,e");
     fprintf(nw, "\n ld ($800D),a\n call $8D74\n.dw $38FA\n ret\n");
    }
    if (ti[3] == 1) {
     fprintf(nw, "\nClrG:\n ld hl,$88B8\n ld de,$88B9\n ld bc,767\n ld (hl),0");
     fprintf(nw, "\n ldir\n ret\n");
    }
    if (ti[4] == 1) {
     fprintf(nw, "\nPutSm:\n ld a,d\n ld ($8216),a\n ld a,e");
     fprintf(nw, "\n ld ($8215),a\n call $8D74\n.dw $37D4\n ret\n");
    }
    if (ti[5] == 1) fprintf(nw, "\nPause:\n call $01D4\n or a\n jr z,Pause\n ret\n");
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d\nCore:\n");
     fprintf(nw, " ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n");
     fprintf(nw, " djnz Core\n ld bc,12\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n");
     fprintf(nw, " djnz DecLoop\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 84 || y == 88 || y == 90) {
    if (ti[1] == 1) {
     fprintf(nw, "\nPutBig:\n ld a,d\n ld ($844B),a\n ld a,e");
     fprintf(nw, "\n ld ($844C),a\n rst 28h\n .dw $450A\n ret\n");
    }
    if (ti[3] == 1) {
     fprintf(nw, "\nClrG:\n ld hl,$9340\n ld de,$9341\n ld bc,767\n ld (hl),0");
     fprintf(nw, "\n ldir\n ret\n");
    }
    if (ti[4] == 1) {
     fprintf(nw, "\nPutSm:\n ld a,d\n ld ($86D8),a\n ld a,e");
     fprintf(nw, "\n ld ($86D7),a\n rst 28h\n .dw $4561\n ret\n");
    }
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d");
     fprintf(nw, "\nCore:\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n djnz Core");
     fprintf(nw, "\n ld bc,12\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n djnz DecLoop");
     fprintf(nw, "\n pop bc\n djnz Height\n ret\n");
    }
   if (ti[7] == 1) {
     fprintf(nw, "\nDispG:\n push af\n di\n ld a,$80\n out ($10),a\n ld hl,$9340-12-(-(12*64)+1)");
     fprintf(nw, "\n ld a,$20\n ld c,a\n inc hl\n dec hl\nfastCopyAgain:\n ld b,64");
     fprintf(nw, "\n inc c\n ld de,-(12*64)+1\n out ($10),a\n add hl,de\n ld de,10");
     fprintf(nw, "\nfastCopyLoop:\n add hl,de\n inc hl\n inc hl\n inc de\n ld a,(hl)");
     fprintf(nw, "\n out ($11),a\n dec de\n djnz fastCopyLoop\n ld a,c\n cp $2C");
     fprintf(nw, "\n jr nz,fastCopyAgain\n pop af\n ret\n");
    }
   }

   fflush(nw);
 }
  fprintf(nw, "\n\n.end");
  fflush(nw);
  printf("\n\nCongratulations!!!\nYour file is converted.\n");
  printf("Old File Size: %d\n", filelength(fileno(fp)));
  printf("New File Size: %d\n\n", filelength(fileno(nw)));
  if (y == 82 || y == 87 || y == 88 || y == 89 || y == 90) {
   printf("Please use with ");
   if (y == 82) printf("Crash 1.6 on the TI-82.\n\n");
   if (y == 87) printf("Doors CS 5.0 on the TI-83.\n\n");
   if (y == 88) printf("MirageOS on the TI-83+.\n\n");
   if (y == 89) printf("Ion 1.6 on the TI-83.\n\n");
   if (y == 90) printf("Ion 1.6 on the TI-83+.\n\n");
   }

  fcloseall();
 }
}


